Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/Vision.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/Vision.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/Vision.asm	(revision 392)
@@ -0,0 +1,251 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Functions for initializing QDI Vision
+;					QD6500 and QD6580 VLB IDE Controllers.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.		
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+;		
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; Vision_DetectAndReturnIDinAXandPortInDXifControllerPresent
+;	Parameters:
+;		Nothing
+;	Returns:
+;		AX:		ID WORD specific for QDI Vision Controllers
+;				(AL = QD65xx Config Register contents)
+;				(AH = QDI Vision Controller ID (bits 4...7))
+;		DX:		Controller port (not IDE port)
+;		ZF:		Set if controller found
+;				Cleared if supported controller not found (AX,DX = undefined)
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+Vision_DetectAndReturnIDinAXandPortInDXifControllerPresent:
+	; Check QD65xx base port
+	mov		dx, QD65XX_BASE_PORT
+	in		al, QD65XX_BASE_PORT + QD65XX_CONFIG_REGISTER_in
+	call	IsConfigRegisterWithIDinAL
+	je		SHORT VisionControllerDetected
+
+	; Check QD65xx alternative base port
+	or		dl, QD65XX_ALTERNATIVE_BASE_PORT
+	in		al, QD65XX_ALTERNATIVE_BASE_PORT + QD65XX_CONFIG_REGISTER_in
+	; Fall to IsConfigRegisterWithIDinAL
+
+;--------------------------------------------------------------------
+; IsConfigRegisterWithIDinAL
+;	Parameters:
+;		AL:		Possible QD65xx Config Register contents
+;	Returns:
+;		AH		QDI Vision Controller ID or undefined
+;		ZF:		Set if controller found
+;				Cleared if supported controller not found (AH = undefined)
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+IsConfigRegisterWithIDinAL:
+	mov		ah, al
+	and		al, MASK_QDCONFIG_CONTROLLER_ID
+	cmp		al, ID_QD6500 << 4
+	je		SHORT VisionControllerDetected
+	cmp		al, ID_QD6580 << 4
+	je		SHORT VisionControllerDetected
+	cmp		al, ID_QD6580_ALTERNATE << 4
+VisionControllerDetected:
+	xchg	ah, al
+	ret
+
+
+;--------------------------------------------------------------------
+; Vision_DoesIdePortInBXbelongToControllerWithIDinAX
+;	Parameters:
+;		AL:		QD65xx Config Register contents
+;		AH:		QDI Vision Controller ID (bits 4...7)
+;		BX:		IDE Base port to check
+;		DX:		Vision Controller port
+;	Returns:
+;		ZF:		Set if port belongs to controller
+;				Cleared if port belongs to another controller
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+Vision_DoesIdePortInBXbelongToControllerWithIDinAX:
+	cmp		ah, ID_QD6500 << 4
+	je		SHORT .DoesIdePortInDXbelongToQD6500
+
+	; QD6580 always have Primary IDE at 1F0h
+	; Secondary IDE at 170h can be enabled or disabled
+	cmp		bx, DEVICE_ATA_DEFAULT_PORT
+	je		SHORT .ReturnResultInZF
+
+	; Check if Secondary IDE channel is enabled
+	push	ax
+	add		dx, BYTE QD6580_CONTROL_REGISTER
+	in		al, dx
+	sub		dx, BYTE QD6580_CONTROL_REGISTER
+	test	al, FLG_QDCONTROL_SECONDARY_DISABLED_in
+	pop		ax
+	jz		SHORT .CompareBXtoSecondaryIDE
+	ret
+
+	; QD6500 has only one IDE channel that can be at 1F0h or 170h
+.DoesIdePortInDXbelongToQD6500:
+	test	al, FLG_QDCONFIG_PRIMARY_IDE
+	jz		SHORT .CompareBXtoSecondaryIDE
+	cmp		bx, DEVICE_ATA_DEFAULT_PORT
+	ret
+
+.CompareBXtoSecondaryIDE:
+	cmp		bx, DEVICE_ATA_DEFAULT_SECONDARY_PORT
+.ReturnResultInZF:
+	ret
+
+
+;--------------------------------------------------------------------
+; Vision_GetMaxPioModeToAL
+;	Parameters:
+;		AL:		QD65xx Config Register contents
+;		AH:		QDI Vision Controller ID (bits 4...7)
+;	Returns:
+;		AL:		Max supported PIO mode
+;		AH:		FLGH_DPT_IORDY if IORDY supported, zero otherwise
+;		CF:		Set if PIO limit necessary
+;				Cleared if no need to limit timings
+;	Corrupts registers:
+;		(AX if CF cleared)
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+Vision_GetMaxPioModeToAL:
+	cmp		ah, ID_QD6500 << 4
+	clc
+	jne		SHORT .NoNeedToLimitForQD6580
+
+	mov		ax, 2	; Limit to PIO 2 because QD6500 does not support IORDY
+	stc
+.NoNeedToLimitForQD6580:
+	ret
+
+
+;--------------------------------------------------------------------
+; Vision_InitializeWithIDinAHandConfigInAL
+;	Parameters:
+;		AL:		QD65xx Config Register contents
+;		AH:		QDI Vision Controller ID (bits 4...7)
+;		DS:DI:	Ptr to DPT for Single or Slave Drive
+;		SI:		Offset to Master DPT if Slave Drive present
+;				Zero if Slave Drive not present
+;	Returns:
+;		CF:		Cleared if success
+;				Set if error
+;	Corrupts registers:
+;		AX, BX, CX, DX, BP
+;--------------------------------------------------------------------
+Vision_InitializeWithIDinAHandConfigInAL:
+	; QD6580 has a Control Register that needs to be programmed
+	mov		dx, [di+DPT_ADVANCED_ATA.wControllerBasePort]
+	cmp		ah, ID_QD6500 << 4
+	je		SHORT .CalculateTimingForQD6500
+
+	; Program QD6580 Control Register (not available on QD6500) to
+	; Enable or Disable Read-Ahead and Post-Write Buffer to match
+	; jumper setting on the multi I/O card.
+	xor		ax, ax
+	add		dx, BYTE QD6580_CONTROL_REGISTER
+	in		al, dx									; Read to get ATAPI jumper status
+	test	al, FLG_QDCONTROL_HDONLY_in
+	eCMOVNZ	ah, FLG_QDCONTROL_NONATAPI				; Enable Read-Ahead and Post-Write Buffers
+	or		ah, MASK_QDCONTROL_FLAGS_TO_SET
+	mov		al, ah
+	out		dx, al
+	sub		dx, BYTE QD6580_CONTROL_REGISTER
+
+	; Now we need to determine is the drive connected to the Primary or Secondary channel.
+	; QD6500 has only one channel that can be Primary at 1F0h or Secondary at 170h.
+	; QD6580 always has Primary channel at 1F0h. Secondary channel at 170h can be Enabled or Disabled.
+	call	AccessDPT_GetIdeBasePortToBX
+	cmp		bx, DEVICE_ATA_DEFAULT_PORT
+	je		SHORT .CalculateTimingTicksForQD6580	; Primary Channel so no need to modify DX
+	times 2 inc dx									; Secondary Channel IDE Timing Register
+
+	; QD6500 and QD6580 require slightly different calculations.
+.CalculateTimingTicksForQD6580:
+	mov		bp, QD6580_MAX_ACTIVE_TIME_CLOCKS | (QD6580_MIN_ACTIVE_TIME_CLOCKS << 8)
+	jmp		SHORT .CalculateTimingsForQD65xx
+
+.CalculateTimingForQD6500:
+	mov		bp, QD6500_MAX_ACTIVE_TIME_CLOCKS | (QD6500_MIN_ACTIVE_TIME_CLOCKS << 8)
+
+	; We need the PIO Cycle Time in CX to calculate Active and Recovery Times.
+.CalculateTimingsForQD65xx:
+	call	AdvAtaInit_SelectSlowestCommonPioTimingsToBXandCXfromDSSIandDSDI
+
+	; Calculate Active Time value for QD65xx IDE Timing Register
+	call	AtaID_GetActiveTimeToAXfromPioModeInBX
+	call	ConvertNanosecsFromAXwithLimitsInBPtoRegisterValue
+	xchg	bp, ax
+
+	; Calculate Recovery Time value for QD65xx IDE Timing Register
+	call	AtaID_GetRecoveryTimeToAXfromPioModeInBXandCycleTimeInCX
+	mov		bx, bp						; Active Time value now in BL
+	mov		bp, QD65xx_MAX_RECOVERY_TIME_CLOCKS | (QD65xx_MIN_RECOVERY_TIME_CLOCKS << 8)
+	call	ConvertNanosecsFromAXwithLimitsInBPtoRegisterValue
+
+	; Merge the values to a single byte to output
+	eSHIFT_IM	al, POSITON_QD65XXIDE_RECOVERY_TIME, shl
+	or		al, bl
+	out		dx, al
+	ret									; Return with CF cleared
+
+
+;--------------------------------------------------------------------
+; ConvertNanosecsFromAXwithLimitsInBPtoRegisterValue
+;	Parameters:
+;		AX:		Nanosecs to convert
+;		BP:		Low Byte:	Maximum allowed ticks
+;				High Byte:	Minimum allowed ticks
+;		DS:DI:	Ptr to DPT for Single or Slave Drive
+;	Returns:
+;		AL:		Timing value for QD65xx register
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+ConvertNanosecsFromAXwithLimitsInBPtoRegisterValue:
+	push	cx
+
+	; Get VLB Cycle Time in nanosecs
+	mov		cl, VLB_33MHZ_CYCLE_TIME	; Assume 33 MHz or slower VLB bus
+	test	BYTE [di+DPT_ADVANCED_ATA.wControllerID], FLG_QDCONFIG_ID3
+	eCMOVZ	cl, VLB_40MHZ_CYCLE_TIME
+
+	; Convert value in AX to VLB ticks
+	div		cl							; AL = VLB ticks
+	inc		ax							; Round up
+
+	; Limit value to QD65xx limits
+	mov		cx, bp
+	MAX_U	al, ch						; Make sure not below minimum
+	MIN_U	al, cl						; Make sure not above maximum
+
+	; Not done yet, we need to invert the ticks since 0 is the slowest
+	; value on the timing register
+	sub		cl, al
+	xchg	ax, cx						; Return in AL
+
+	pop		cx
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm	(revision 392)
@@ -55,5 +55,4 @@
 	jcxz	.AddHardDisks					; Set to zero on .ideVarsSerialAuto iteration (if any)
 %endif
-
 	loop	.DriveDetectLoop
 
@@ -155,4 +154,5 @@
 StartDetectionWithDriveSelectByteInBHandStringInCX:
 	call	DetectPrint_StartDetectWithMasterOrSlaveStringInCXandIdeVarsInCSBP
+	call	HotkeyBar_UpdateDuringDriveDetection
 	; Fall to .ReadAtaInfoFromHardDisk
 
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 392)
@@ -22,14 +22,28 @@
 
 ;--------------------------------------------------------------------
-; BootMenuPrint_InitializeDisplayContext
-;	Parameters:
-;		Nothing
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, DI
-;--------------------------------------------------------------------
-BootMenuPrint_InitializeDisplayContext:
-	CALL_DISPLAY_LIBRARY InitializeDisplayContext
+; DetectPrint_InitializeDisplayContext
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+DetectPrint_InitializeDisplayContext:
+	CALL_DISPLAY_LIBRARY	InitializeDisplayContext
+	ret
+
+
+;--------------------------------------------------------------------
+; DetectPrint_GetSoftwareCoordinatesToAX
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+DetectPrint_GetSoftwareCoordinatesToAX:
+	CALL_DISPLAY_LIBRARY	GetSoftwareCoordinatesToAX
 	ret
 
@@ -186,5 +200,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, SI, DI
+;		AX, DH, SI, DI
 ;--------------------------------------------------------------------
 DetectPrint_TryToBootFromDL:
@@ -192,15 +206,16 @@
 	mov		bp, sp
 
-	mov		ax, g_szHDD
-	test	dl, dl
-	js		SHORT .NotFDD
-	mov		ax, g_szFDD
-.NotFDD:
-	push	ax
-
-	call	DriveXlate_ToOrBack
-	push	dx					; Push untranslated drive number
-	call	DriveXlate_ToOrBack
-	push	dx					; Push translated drive number
+	call	DriveXlate_ToOrBack	; DL = Untranslated Drive number
+	mov		dh, dl
+	call	DriveXlate_ToOrBack	; DL = Translated Drive number
+
+	call	HotkeyBar_ConvertDriveNumberFromDLtoDriveLetter	; DL = Translated letter
+	xchg	dl, dh
+	call	HotkeyBar_ConvertDriveNumberFromDLtoDriveLetter	; DL = Untranslated letter
+	push	dx
+	xchg	dl, dh
+	push	dx
+
+	call	ConvertDriveLetterInDLtoDriveNumber	; Restore DL
 
 	mov		si, g_szTryToBoot
@@ -226,5 +241,5 @@
 	push	bp
 	mov		bp,sp
-	; Fall to BootMenuPrint_FormatCSSIfromParamsInSSBP
+	; Fall to DetectPrint_FormatCSSIfromParamsInSSBP
 
 ;--------------------------------------------------------------------
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/FloppyDrive.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/FloppyDrive.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/FloppyDrive.asm	(revision 392)
@@ -125,4 +125,5 @@
 ;		AX, CX, DX, DI, ES
 ;--------------------------------------------------------------------
+%ifdef MODULE_BOOT_MENU
 FloppyDrive_GetType:
 	mov		ah, 08h			; Get Drive Parameters
@@ -130,4 +131,5 @@
 	int		BIOS_DISKETTE_INTERRUPT_40h
 	ret
+%endif
 
 
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 392)
@@ -69,7 +69,8 @@
 ;--------------------------------------------------------------------
 Initialize_AndDetectDrives:
-	call	BootMenuPrint_InitializeDisplayContext
+	call	DetectPrint_InitializeDisplayContext
 	call	DetectPrint_RomFoundAtSegment
 	call	RamVars_Initialize
+	call	BootVars_Initialize
 	call	Interrupts_InitializeInterruptVectors
 	call	DetectDrives_FromAllIDEControllers
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 392)
@@ -63,4 +63,9 @@
 	mov		si, Int13h_DiskFunctionsHandler		; Interrupt handler offset
 	call	Interrupts_InstallHandlerToVectorInALFromCSSI
+
+	; Install INT 19h handler to properly reset the system
+	mov		al, BIOS_BOOT_LOADER_INTERRUPT_19h	; INT 19h interrupt vector offset
+	mov		si, Int19hReset_Handler				; INT 19h handler to reboot the system
+	call	Interrupts_InstallHandlerToVectorInALFromCSSI
 	; Fall to .InitializeHardwareIrqHandlers
 
Index: trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 392)
@@ -34,9 +34,10 @@
 %define	EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS	; Exclude unused library functions
 %ifdef MODULE_BOOT_MENU
-	%define MENUEVENT_INLINE_OFFSETS    ; Only one menu required, save space and inline offsets
+	%define MENUEVENT_INLINE_OFFSETS    	; Only one menu required, save space and inline offsets
 	%define INCLUDE_MENU_LIBRARY
 
 %else	; If no boot menu included
 	%define	INCLUDE_DISPLAY_LIBRARY
+	%define INCLUDE_KEYBOARD_LIBRARY
 	%define INCLUDE_TIME_LIBRARY
 %endif
@@ -57,4 +58,5 @@
 	%include "RamVars.inc"			; For RAMVARS struct
 	%include "BootVars.inc"			; For BOOTVARS struct
+	%include "HotkeyBar.inc"		; For Hotkeys
 	%include "BootMenu.inc"			; For Boot Menu
 	%include "IDE_8bit.inc"			; For IDE 8-bit data port macros
@@ -212,4 +214,6 @@
 	%include "Interrupts.asm"		; For Interrupt initialization
 	%include "RamVars.asm"			; For RAMVARS initialization and access
+	%include "BootVars.asm"			; For initializing variabled used during init and boot
+	%include "FloppyDrive.asm"		; Floppy Drive related functions
 	%include "CreateDPT.asm"		; For creating DPTs
 	%include "FindDPT.asm"			; For finding DPTs
@@ -220,4 +224,5 @@
 	%include "DetectDrives.asm"		; For detecting IDE drives
 	%include "DetectPrint.asm"		; For printing drive detection strings
+	%include "HotkeyBar.asm"		; For hotkeys during drive detection and boot menu
 
 	; Boot menu
@@ -232,5 +237,5 @@
 	; Boot loader
 	%include "Int19h.asm"			; For Int 19h, Boot Loader
-	%include "FloppyDrive.asm"		; Floppy Drive related functions
+	%include "Int19hReset.asm"		; INT 19h handler for proper system reset
 	%include "BootSector.asm"		; For loading boot sector
 
Index: trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenu.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenu.asm	(revision 392)
@@ -0,0 +1,72 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Displays Boot Menu.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html		
+;		
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; Displays Boot Menu and returns Drive or Function number.
+;
+; BootMenu_DisplayAndReturnSelectionInDX
+;	Parameters:
+;		DS:		RAMVARS segment
+;	Returns:
+;		Nothing, selected drive is converted to hotkey
+;	Corrupts registers:
+;		All General Purpose Registers
+;--------------------------------------------------------------------
+BootMenu_DisplayAndStoreSelectionAsHotkey:
+	call	DriveXlate_Reset
+
+	mov		bx, BootMenuEvent_Handler
+	CALL_MENU_LIBRARY	DisplayWithHandlerInBXandUserDataInDXAX
+
+	; Clear Boot Menu from screen
+	mov		ax, ' ' | (MONO_NORMAL<<8)
+	CALL_DISPLAY_LIBRARY	ClearScreenWithCharInALandAttrInAH
+	ret
+
+
+;--------------------------------------------------------------------
+; BootMenu_GetDriveToDXforMenuitemInCX
+;	Parameters:
+;		CX:		Index of menuitem selected from Boot Menu
+;	Returns:
+;		DX:		Drive number to be used for booting
+;		DS:		RAMVARS segment
+;       CF:     Set: There is a selected menu item, DL is valid
+;               Clear: There is no selected menu item, DL is not valid
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+BootMenu_GetDriveToDXforMenuitemInCX:
+	cmp		cl, NO_ITEM_HIGHLIGHTED
+	je		SHORT .ReturnFloppyDriveInDX	; Clear CF if branch taken
+
+	mov		dl, cl							; Copy menuitem index to DX
+	call	FloppyDrive_GetCountToAX
+	cmp		dl, al							; Floppy drive?
+	jb		SHORT .ReturnFloppyDriveInDX	; Set CF if branch taken
+	or		al, 80h							; Or 80h into AL before the sub
+											; to cause CF to be set after
+											; and result has high order bit set
+	sub		dl, al							; Remove floppy drives from index
+
+.ReturnFloppyDriveInDX:
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuEvent.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuEvent.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuEvent.asm	(revision 392)
@@ -0,0 +1,344 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Boot Menu event handler for menu library callbacks.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.		
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html		
+;		
+
+; Section containing code
+SECTION .text
+
+
+;--------------------------------------------------------------------
+; GetDefaultMenuitemToDL
+;	Parameters:
+;		DL:		Drive number
+;		ES:		Ptr to BDA (zero)
+;	Returns:
+;		DL:		Menuitem index (assuming drive is available)
+;	Corrupts registers:
+;		AX, DH
+;--------------------------------------------------------------------
+GetDefaultMenuitemToDX:
+	mov		dx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters]
+	test	BYTE [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFlags], FLG_HOTKEY_HD_FIRST
+	eCMOVZ	dl, dh
+	call	IsDriveDLinSystem
+	jnc		SHORT DoNotSetDefaultMenuitem
+	call	DriveXlate_SetDriveToSwap
+	; Fall to GetMenuitemToDXforDriveInDL
+
+
+;--------------------------------------------------------------------
+; GetMenuitemToDXforDriveInDL
+;	Parameters:
+;		DL:		Drive number
+;	Returns:
+;		DX:		Menuitem index (assuming drive is available)
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+GetMenuitemToDXforDriveInDL:
+	xor		dh, dh						; Drive number now in DX
+	test	dl, dl
+	jns		SHORT .ReturnItemIndexInDX	; Return if floppy drive (HD bit not set)
+	call	FloppyDrive_GetCountToAX
+	and		dl, ~80h					; Clear HD bit
+	add		dx, ax
+.ReturnItemIndexInDX:
+	ret
+
+
+;--------------------------------------------------------------------
+; IsDriveDLinSystem
+;	Parameters:
+;		DL:		Drive number
+;		DS:		RAMVARS segment
+;	Returns:
+;		CF:		Set if drive number is valid
+;				Clear if drive is not present in system
+;	Corrupts registers:
+;		AX, CX
+;--------------------------------------------------------------------
+IsDriveDLinSystem:
+	test	dl, dl								; Floppy drive?
+	jns		SHORT .IsFloppyDriveInSystem
+	call	RamVars_GetHardDiskCountFromBDAtoAX	; Hard Disk count to AX
+	or		al, 80h								; Set Hard Disk bit to AX
+	jmp		SHORT .CompareDriveNumberToDriveCount
+.IsFloppyDriveInSystem:
+	call	FloppyDrive_GetCountToAX
+.CompareDriveNumberToDriveCount:
+	cmp		dl, al								; Set CF when DL is smaller
+	ret
+
+
+;--------------------------------------------------------------------
+; ConvertKeystrokeToAXfromDriveLetterInDL
+;	Parameters:
+;		DL:		Drive Letter ('A'...)
+;	Returns:
+;		AX:		Hotkey keystroke
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+ConvertKeystrokeToAXfromDriveLetterInDL:
+	eMOVZX	ax, dl
+	jmp		Char_ChangeCaseInAL	; Upper case drive letter to lower case keystroke
+
+
+;--------------------------------------------------------------------
+; BootMenuEvent_Handler
+;	Common parameters for all events:
+;		BX:			Menu event (anything from MENUEVENT struct)
+;		SS:BP:		Menu library handle
+;	Common return values for all events:
+;		CF:			Set if event processed
+;					Cleared if event not processed
+;	Corrupts registers:
+;		All
+;--------------------------------------------------------------------
+BootMenuEvent_Handler:
+	LOAD_BDA_SEGMENT_TO	es, di
+	call	RamVars_GetSegmentToDS
+
+%ifdef MENUEVENT_INLINE_OFFSETS
+
+	add		bx, FirstEvent
+	jmp		bx
+
+EventNotHandled:
+DoNotSetDefaultMenuitem:
+	xor		dx, dx		; Clear CF (and menuitem index for DoNotSetDefaultMenuitem)
+	ret
+
+MENUEVENT_InitializeMenuinitFromDSSI equ  (EventInitializeMenuinitFromSSBP - FirstEvent)
+MENUEVENT_ExitMenu equ  (BootMenuEvent_Completed - FirstEvent)
+MENUEVENT_ItemHighlightedFromCX equ (EventItemHighlightedFromCX - FirstEvent)
+MENUEVENT_ItemSelectedFromCX equ (EventItemSelectedFromCX - FirstEvent)
+MENUEVENT_KeyStrokeInAX equ (EventKeyStrokeInAX - FirstEvent)
+MENUEVENT_RefreshTitle equ (BootMenuPrint_TitleStrings - FirstEvent)
+MENUEVENT_RefreshInformation equ (BootMenuPrint_RefreshInformation - FirstEvent)
+MENUEVENT_RefreshItemFromCX equ (BootMenuPrint_RefreshItem - FirstEvent)
+;
+; Note that there is no entry for MENUEVENT_IdleProcessing.  If MENUEVENT_IDLEPROCESSING_ENABLE is not %defined,
+; then the entry point will not be called (saving memory on this end and at the CALL point).
+;
+
+%else
+
+	cmp		bx, BYTE MENUEVENT.RefreshItemFromCX	; Above last supported item?
+	ja		SHORT EventNotHandled
+	jmp		[cs:bx+rgfnEventSpecificHandlers]
+
+EventNotHandled:
+DoNotSetDefaultMenuitem:
+	xor		dx, dx		; Clear CF (and menuitem index for DoNotSetDefaultMenuitem)
+	ret
+
+rgfnEventSpecificHandlers:
+	dw		EventInitializeMenuinitFromSSBP		; MENUEVENT.InitializeMenuinitFromDSSI
+	dw		EventCompleted						; MENUEVENT.ExitMenu
+	dw		EventNotHandled						; MENUEVENT.IdleProcessing
+	dw		EventItemHighlightedFromCX			; MENUEVENT.ItemHighlightedFromCX
+	dw		EventItemSelectedFromCX				; MENUEVENT.ItemSelectedFromCX
+	dw		EventKeyStrokeInAX					; MENUEVENT.KeyStrokeInAX
+	dw		BootMenuPrint_TitleStrings			; MENUEVENT.RefreshTitle
+	dw		BootMenuPrint_RefreshInformation	; MENUEVENT.RefreshInformation
+	dw		BootMenuPrint_RefreshItem			; MENUEVENT.RefreshItemFromCX
+
+%endif
+
+
+;--------------------------------------------------------------------
+; EventInitializeMenuinitFromSSBP
+;	Parameters
+;		DS:		Ptr to RAMVARS
+;		ES:		Ptr to BDA (zero)
+;		SS:BP:	Ptr to MENUINIT struct to initialize
+;	Returns:
+;		CF:		Set if event processed
+;				Cleared if event not processed
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+FirstEvent:	
+EventInitializeMenuinitFromSSBP:
+	; Store default Menuitem (=default drive to boot from)
+	call	GetDefaultMenuitemToDX
+	mov		[bp+MENUINIT.wHighlightedItem], dx
+
+	; Store number of Menuitems
+	call	RamVars_GetHardDiskCountFromBDAtoAX
+	xchg	ax, cx
+	call	FloppyDrive_GetCountToAX
+	add		ax, cx
+	mov		[bp+MENUINIT.wItems], ax
+
+	; Store menu size
+	mov		WORD [bp+MENUINIT.wTitleAndInfoLines], BOOT_MENU_TITLE_AND_INFO_LINES
+	mov		BYTE [bp+MENUINIT.bWidth], BOOT_MENU_WIDTH
+	add		al, BOOT_MENU_HEIGHT_WITHOUT_ITEMS
+	xchg	cx, ax
+	CALL_DISPLAY_LIBRARY	GetColumnsToALandRowsToAH
+	sub		ah, MENU_SCREEN_BOTTOM_LINES*2	; Leave space for Hotkey Bar
+	MIN_U	ah, cl
+	mov		[bp+MENUINIT.bHeight], ah
+
+	; Store selection timeout
+	mov		ax, [cs:ROMVARS.wBootTimeout]
+	CALL_MENU_LIBRARY StartSelectionTimeoutWithTicksInAX
+	stc
+	ret
+
+
+;--------------------------------------------------------------------
+; EventItemHighlightedFromCX
+;	Parameters
+;		CX:		Index of new highlighted item
+;		DX:		Index of previously highlighted item or NO_ITEM_HIGHLIGHTED
+;		DS:		Ptr to RAMVARS
+;		ES:		Ptr to BDA (zero)
+;		SS:BP:	Menu library handle
+;	Returns:
+;		CF:		Set if event processed
+;				Cleared if event not processed
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+EventItemHighlightedFromCX:
+	push	cx
+	call	BootMenu_GetDriveToDXforMenuitemInCX		
+	call	DriveXlate_Reset
+	call	DriveXlate_SetDriveToSwap
+
+	; We need to generate keystroke so selection two drives is possible.
+	; The secondary boot drive is selected by highlighting it using menu keys
+	; and the primary boot drive is selected by pressing drive letter hotkey.
+	call	HotkeyBar_ConvertDriveNumberFromDLtoDriveLetter
+	call	ConvertKeystrokeToAXfromDriveLetterInDL
+	call	HotkeyBar_StoreHotkeyToBootvarsIfValidKeystrokeInAX
+	call	RedrawHotkeyBarFromInsideMenuEventHandler
+
+	; Redraw changes in drive numbers
+	xor		ax, ax	; Update first floppy drive (for translated drive number)
+	CALL_MENU_LIBRARY	RefreshItemFromAX
+	mov		dl, 80h
+	call	GetMenuitemToDXforDriveInDL
+	xchg	ax, dx	; Update first hard disk (for translated drive number)
+	CALL_MENU_LIBRARY	RefreshItemFromAX
+	pop		ax		; Update new item (for translated drive number)
+	CALL_MENU_LIBRARY	RefreshItemFromAX
+	CALL_MENU_LIBRARY	RefreshInformation
+	stc
+	ret
+
+
+;--------------------------------------------------------------------
+; EventItemSelectedFromCX
+;	Parameters
+;		CX:		Index of selected item
+;		DS:		Ptr to RAMVARS
+;		ES:		Ptr to BDA (zero)
+;		SS:BP:	Menu library handle
+;	Returns:
+;		CF:		Set if event processed
+;				Cleared if event not processed
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+EventItemSelectedFromCX:
+	call	BootMenu_GetDriveToDXforMenuitemInCX
+	jnc		SHORT BootMenuEvent_Completed	; No menuitem selected
+
+	; Convert selected drive to hotkey keystroke
+	call	HotkeyBar_ConvertDriveNumberFromDLtoDriveLetter
+	call	ConvertKeystrokeToAXfromDriveLetterInDL
+	; Fall to EventKeyStrokeInAX
+
+
+;--------------------------------------------------------------------
+; EventKeyStrokeInAX
+;	Parameters
+;		AL:		ASCII character for the key
+;		AH:		Keyboard library scan code for the key
+;		DS:		Ptr to RAMVARS
+;		ES:		Ptr to BDA (zero)
+;		SS:BP:	Menu library handle
+;	Returns:
+;		CF:		Set if event processed
+;				Cleared if event not processed
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+EventKeyStrokeInAX:
+	cmp		ah, BOOT_MENU_HOTKEY_SCANCODE
+	je		SHORT BootMenuEvent_Completed	; Ignore Boot Menu hotkey
+	call	HotkeyBar_StoreHotkeyToBootvarsIfValidKeystrokeInAX
+	jnc		SHORT BootMenuEvent_Completed
+
+	; Hotkey is now stored to BOOTVARS and menu can be closed
+	; Fall to CloseBootMenu
+
+
+;--------------------------------------------------------------------
+; CloseBootMenu
+;	Parameters
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+CloseBootMenu:
+	call	DriveXlate_Reset
+	CALL_MENU_LIBRARY	Close
+	; Fall to RedrawHotkeyBarFromInsideMenuEventHandler
+
+
+;--------------------------------------------------------------------
+; RedrawHotkeyBarFromInsideMenuEventHandler
+;	Parameters
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+RedrawHotkeyBarFromInsideMenuEventHandler:
+	mov		al, MONO_NORMAL
+	CALL_DISPLAY_LIBRARY	SetCharacterAttributeFromAL
+
+	mov		bl, ATTRIBUTES_ARE_USED
+	mov		ax, TELETYPE_OUTPUT_WITH_ATTRIBUTE
+	CALL_DISPLAY_LIBRARY	SetCharOutputFunctionFromAXwithAttribFlagInBL
+	call	HotkeyBar_DrawToTopOfScreen
+	; Fall to BootMenuEvent_Completed
+
+
+;--------------------------------------------------------------------
+; BootMenuEvent_Completed
+;	Parameters
+;		Nothing
+;	Returns:
+;		CF:		Set to exit from menu
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+BootMenuEvent_Completed:
+	stc
+	ret
